#include <iostream>

using namespace std;

int niz[200008];
int l[200008], r[200008];
int doi[200008];
int jedinice[200008];
int zadnja1[200008];
int prva2[200008];

int main()
{
    int n; cin >> n;
    bool ehehe = true;

    for(int i = 0; i < n; i++)
    {
        cin >> niz[i];
        if(niz[i] != 1 && niz[i] != 2)
            ehehe = false;
    }

    int q; cin >> q;

    doi[0] = 0;
    int brisanja = 0;
    int poslednji = 0;

    for(int i = 0; i < q; i++)
    {
        cin >> l[i] >> r[i];
    }


    if(ehehe)
    {
        for(int i = 0; i < n; i++)
        {
            if(niz[i] == 1)
            {
                if(i == 0)
                    jedinice[i] = 1;
                else
                    jedinice[i] = jedinice[i - 1] + 1;

                zadnja1[i] = i;
            }
            else
            {
                if(i == 0)
                {
                    jedinice[i] = 0;
                    zadnja1[i] = -1;
                }


                zadnja1[i] = zadnja1[i - 1];
            }
        }

        for(int i = n - 1; i >= 0; i--)
        {
            if(niz[i] == 2)
            {
                prva2[i] = i;
            }
            else
            {
                if(i == n - 1)
                    prva2[i] = -1;
                else
                    prva2[i] = prva2[i + 1];
            }
        }

        for(int i = 1; i < q; i++)
        {
            int levo = prva2[l[i]];
            int desno = zadnja1[r[i]];

            if(levo > desno)
                cout << "DA" << endl;
            else
            {
                int brojeva = desno - levo + 1;
                int jedinica = jedinice[desno] - jedinice[levo - 1];
                int dvojki = brojeva - jedinica;
                if(min(jedinica, dvojki) <= 1)
                    cout << "DA" << endl;
                else
                    cout << "NE" << endl;
            }
        }
    }
    else
    {
        for(int i = 1; i < n; i++)
        {
            if(niz[i] < niz[poslednji])
            {
                brisanja++;
            }

            doi[i] = brisanja;
            poslednji = i;
        }

        for(int i = 0; i < q; i++)
        {
            int br;
            br = doi[r[i] - 1] - doi[l[i] - 1];

            if(r[i] - l[i] <= 1)
            {
                cout << "DA" << endl;
            }
            else if(br <= 1)
            {
                cout << "DA" << endl;
            }
            else
            {
                cout << "NE" << endl;
            }
        }
    }




    return 0;
}